<?php

/**
 * Implements hook_rules_action_info().
 */
function manticore_rules_action_info() {
  // Action to add a contact to Manticore.
  $actions['manticore_rules_contact'] = array(
    'label' => t('Add a contact to Manticore'),
    'module' => 'Manticore',
    'help' => t('Map all the parameters to make up the Manticore contact here. You must inject Tokens to map the object references.'),
  );
  // Provide the parameters to the Manticore action.
  foreach (manticore_availablefields() as $name => $type) {
    $actions['manticore_rules_contact']['arguments'][$name] = array(
      'type' => $type,
      'label' => $name,
    );
  }
  return $actions;
}

/**
 * Action callback to make all the settings not required.
 */
function manticore_rules_contact_form($settings, &$form) {
  foreach ($form['settings'] as $name => $conf) {
    if (is_array($conf)) {
      if (isset($form['settings'][$name]['#required'])) {
        $form['settings'][$name]['#required'] = FALSE;
      }
    }
  }
}

/**
 * Rules Action callback; Adds a contact to Manticore.
 */
function manticore_rules_contact() {
  // Match the parameters to what was passed in through the Rules.
  $parameters = manticore_availablefields();
  $args = func_get_args();
  $i = 0;
  foreach ($parameters as $name => $type) {
    if (isset($args[$i]) && is_string($args[$i])) {
      $parameters[$name] = trim($args[$i]);
    }
    else {
      unset($parameters[$name]);
    }
    $i++;
  }

  // Filter out any empty arguments.
  $parameters = array_filter($parameters);

  // Make sure at least the email was provided.
  if (isset($parameters['EmailAddress'])) {
    manticore_call($parameters);
  }
}

